VTK: vtkSmoothPolyDataFilter Class Reference

| VTK 9.3.1

Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkSmoothPolyDataFilter Class Reference

adjust point positions using Laplacian smoothing More...

`#include <vtkSmoothPolyDataFilter.h>`

Inheritance diagram for vtkSmoothPolyDataFilter:
[legend]
Collaboration diagram for vtkSmoothPolyDataFilter:
[legend]

## Public Member Functions
virtual void | SetConvergence (double)
| Specify a convergence criterion for the iteration process. More...
virtual double | GetConvergence ()
| Specify a convergence criterion for the iteration process. More...
virtual void | SetNumberOfIterations (int)
| Specify the number of iterations for Laplacian smoothing,. More...
virtual int | GetNumberOfIterations ()
| Specify the number of iterations for Laplacian smoothing,. More...
virtual void | SetRelaxationFactor (double)
| Specify the relaxation factor for Laplacian smoothing. More...
virtual double | GetRelaxationFactor ()
| Specify the relaxation factor for Laplacian smoothing. More...
virtual void | SetFeatureEdgeSmoothing (vtkTypeBool)
| Turn on/off smoothing along sharp interior edges. More...
virtual vtkTypeBool | GetFeatureEdgeSmoothing ()
| Turn on/off smoothing along sharp interior edges. More...
virtual void | FeatureEdgeSmoothingOn ()
| Turn on/off smoothing along sharp interior edges. More...
virtual void | FeatureEdgeSmoothingOff ()
| Turn on/off smoothing along sharp interior edges. More...
virtual void | SetFeatureAngle (double)
| Specify the feature angle for sharp edge identification. More...
virtual double | GetFeatureAngle ()
| Specify the feature angle for sharp edge identification. More...
virtual void | SetEdgeAngle (double)
| Specify the edge angle to control smoothing along edges (either interior or boundary). More...
virtual double | GetEdgeAngle ()
| Specify the edge angle to control smoothing along edges (either interior or boundary). More...
virtual void | SetBoundarySmoothing (vtkTypeBool)
| Turn on/off the smoothing of vertices on the boundary of the mesh. More...
virtual vtkTypeBool | GetBoundarySmoothing ()
| Turn on/off the smoothing of vertices on the boundary of the mesh. More...
virtual void | BoundarySmoothingOn ()
| Turn on/off the smoothing of vertices on the boundary of the mesh. More...
virtual void | BoundarySmoothingOff ()
| Turn on/off the smoothing of vertices on the boundary of the mesh. More...
virtual void | SetGenerateErrorScalars (vtkTypeBool)
| Turn on/off the generation of scalar distance values. More...
virtual vtkTypeBool | GetGenerateErrorScalars ()
| Turn on/off the generation of scalar distance values. More...
virtual void | GenerateErrorScalarsOn ()
| Turn on/off the generation of scalar distance values. More...
virtual void | GenerateErrorScalarsOff ()
| Turn on/off the generation of scalar distance values. More...
virtual void | SetGenerateErrorVectors (vtkTypeBool)
| Turn on/off the generation of error vectors. More...
virtual vtkTypeBool | GetGenerateErrorVectors ()
| Turn on/off the generation of error vectors. More...
virtual void | GenerateErrorVectorsOn ()
| Turn on/off the generation of error vectors. More...
virtual void | GenerateErrorVectorsOff ()
| Turn on/off the generation of error vectors. More...
void | SetSourceData (vtkPolyData *source)
| Specify the source object which is used to constrain smoothing. More...
vtkPolyData * | GetSource ()
| Specify the source object which is used to constrain smoothing. More...
virtual void | SetOutputPointsPrecision (int)
| Set/get the desired precision for the output types. More...
virtual int | GetOutputPointsPrecision ()
| Set/get the desired precision for the output types. More...
Public Member Functions inherited from vtkPolyDataAlgorithm
vtkPolyDataAlgorithm * | NewInstance () const
vtkTypeBool | ProcessRequest (vtkInformation *, vtkInformationVector **, vtkInformationVector *) override
| see vtkAlgorithm for details More...
vtkDataObject * | GetInput ()
vtkDataObject * | GetInput (int port)
vtkPolyData * | GetPolyDataInput (int port)
vtkPolyData * | GetOutput ()
| Get the output data object for a port on this algorithm. More...
vtkPolyData * | GetOutput (int)
| Get the output data object for a port on this algorithm. More...
virtual void | SetOutput (vtkDataObject *d)
| Get the output data object for a port on this algorithm. More...
void | SetInputData (vtkDataObject *)
| Assign a data object as input. More...
void | SetInputData (int, vtkDataObject *)
| Assign a data object as input. More...
void | AddInputData (vtkDataObject *)
| Assign a data object as input. More...
void | AddInputData (int, vtkDataObject *)
| Assign a data object as input. More...
Public Member Functions inherited from vtkAlgorithm
vtkAlgorithm * | NewInstance () const
vtkTypeBool | HasExecutive ()
| Check whether this algorithm has an assigned executive. More...
vtkExecutive * | GetExecutive ()
| Get this algorithm's executive. More...
virtual void | SetExecutive (vtkExecutive *executive)
| Set this algorithm's executive. More...
vtkTypeBool | ProcessRequest (vtkInformation *request, vtkCollection *inInfo, vtkInformationVector *outInfo)
| Version of ProcessRequest() that is wrapped. More...
virtual int | ComputePipelineMTime (vtkInformation *request, vtkInformationVector **inInfoVec, vtkInformationVector *outInfoVec, int requestFromOutputPort, vtkMTimeType *mtime)
| A special version of ProcessRequest meant specifically for the pipeline modified time request. More...
virtual int | ModifyRequest (vtkInformation *request, int when)
| This method gives the algorithm a chance to modify the contents of a request before or after (specified in the when argument) it is forwarded. More...
vtkInformation * | GetInputPortInformation (int port)
| Get the information object associated with an input port. More...
vtkInformation * | GetOutputPortInformation (int port)
| Get the information object associated with an output port. More...
int | GetNumberOfInputPorts ()
| Get the number of input ports used by the algorithm. More...
int | GetNumberOfOutputPorts ()
| Get the number of output ports provided by the algorithm. More...
void | SetAbortExecuteAndUpdateTime ()
| Set AbortExecute Flag and update LastAbortTime. More...
void | UpdateProgress (double amount)
| Update the progress of the process object. More...
bool | CheckAbort ()
| Checks to see if this filter should abort. More...
virtual void | SetInputArrayToProcess (int idx, int port, int connection, const char *fieldAssociation, const char *attributeTypeorName)
| String based versions of SetInputArrayToProcess(). More...
vtkInformation * | GetInputArrayInformation (int idx)
| Get the info object for the specified input array to this algorithm. More...
void | RemoveAllInputs ()
| Remove all the input data. More...
vtkDataObject * | GetOutputDataObject (int port)
| Get the data object that will contain the algorithm output for the given port. More...
vtkDataObject * | GetInputDataObject (int port, int connection)
| Get the data object that will contain the algorithm input for the given port and given connection. More...
virtual void | RemoveInputConnection (int port, vtkAlgorithmOutput *input)
| Remove a connection from the given input port index. More...
virtual void | RemoveInputConnection (int port, int idx)
| Remove a connection given by index idx. More...
virtual void | RemoveAllInputConnections (int port)
| Removes all input connections. More...
virtual void | SetInputDataObject (int port, vtkDataObject *data)
| Sets the data-object as an input on the given port index. More...
virtual void | SetInputDataObject (vtkDataObject *data)
virtual void | AddInputDataObject (int port, vtkDataObject *data)
| Add the data-object as an input to this given port. More...
virtual void | AddInputDataObject (vtkDataObject *data)
vtkAlgorithmOutput * | GetOutputPort (int index)
| Get a proxy object corresponding to the given output port of this algorithm. More...
vtkAlgorithmOutput * | GetOutputPort ()
int | GetNumberOfInputConnections (int port)
| Get the number of inputs currently connected to a port. More...
int | GetTotalNumberOfInputConnections ()
| Get the total number of inputs for this algorithm. More...
vtkAlgorithmOutput * | GetInputConnection (int port, int index)
| Get the algorithm output port connected to an input port. More...
vtkAlgorithm * | GetInputAlgorithm (int port, int index, int &algPort)
| Returns the algorithm and the output port index of that algorithm connected to a port-index pair. More...
vtkAlgorithm * | GetInputAlgorithm (int port, int index)
| Returns the algorithm connected to a port-index pair. More...
vtkAlgorithm * | GetInputAlgorithm ()
| Equivalent to GetInputAlgorithm(0, 0). More...
vtkExecutive * | GetInputExecutive (int port, int index)
| Returns the executive associated with a particular input connection. More...
vtkExecutive * | GetInputExecutive ()
| Equivalent to GetInputExecutive(0, 0) More...
vtkInformation * | GetInputInformation (int port, int index)
| Return the information object that is associated with a particular input connection. More...
vtkInformation * | GetInputInformation ()
| Equivalent to GetInputInformation(0, 0) More...
vtkInformation * | GetOutputInformation (int port)
| Return the information object that is associated with a particular output port. More...
virtual vtkTypeBool | Update (int port, vtkInformationVector *requests)
| This method enables the passing of data requests to the algorithm to be used during execution (in addition to bringing a particular port up-to-date). More...
virtual vtkTypeBool | Update (vtkInformation *requests)
| Convenience method to update an algorithm after passing requests to its first output port. More...
virtual int | UpdatePiece (int piece, int numPieces, int ghostLevels, const int extents[6]=nullptr)
| Convenience method to update an algorithm after passing requests to its first output port. More...
virtual int | UpdateExtent (const int extents[6])
| Convenience method to update an algorithm after passing requests to its first output port. More...
virtual int | UpdateTimeStep (double time, int piece=-1, int numPieces=1, int ghostLevels=0, const int extents[6]=nullptr)
| Convenience method to update an algorithm after passing requests to its first output port. More...
virtual void | UpdateInformation ()
| Bring the algorithm's information up-to-date. More...
virtual void | UpdateDataObject ()
| Create output object(s). More...
virtual void | PropagateUpdateExtent ()
| Propagate meta-data upstream. More...
virtual void | UpdateWholeExtent ()
| Bring this algorithm's outputs up-to-date. More...
void | ConvertTotalInputToPortConnection (int ind, int &port, int &conn)
| Convenience routine to convert from a linear ordering of input connections to a port/connection pair. More...
virtual vtkInformation * | GetInformation ()
| Set/Get the information object associated with this algorithm. More...
virtual void | SetInformation (vtkInformation *)
| Set/Get the information object associated with this algorithm. More...
bool | UsesGarbageCollector () const override
| Participate in garbage collection. More...
virtual void | SetAbortExecute (vtkTypeBool)
| Set/Get the AbortExecute flag for the process object. More...
virtual vtkTypeBool | GetAbortExecute ()
| Set/Get the AbortExecute flag for the process object. More...
virtual void | AbortExecuteOn ()
| Set/Get the AbortExecute flag for the process object. More...
virtual void | AbortExecuteOff ()
| Set/Get the AbortExecute flag for the process object. More...
virtual double | GetProgress ()
| Get the execution progress of a process object. More...
void | SetContainerAlgorithm (vtkAlgorithm *containerAlg)
| Set/get a Container algorithm for this algorithm. More...
vtkAlgorithm * | GetContainerAlgorithm ()
| Set/get a Container algorithm for this algorithm. More...
virtual void | SetAbortOutput (bool)
| Set/Get an internal variable used to communicate between the algorithm and executive. More...
virtual bool | GetAbortOutput ()
| Set/Get an internal variable used to communicate between the algorithm and executive. More...
void | SetProgressShiftScale (double shift, double scale)
| Specify the shift and scale values to use to apply to the progress amount when `UpdateProgress` is called. More...
virtual double | GetProgressShift ()
| Specify the shift and scale values to use to apply to the progress amount when `UpdateProgress` is called. More...
virtual double | GetProgressScale ()
| Specify the shift and scale values to use to apply to the progress amount when `UpdateProgress` is called. More...
void | SetProgressText (const char *ptext)
| Set the current text message associated with the progress state. More...
virtual char * | GetProgressText ()
| Set the current text message associated with the progress state. More...
virtual unsigned long | GetErrorCode ()
| The error code contains a possible error that occurred while reading or writing the file. More...
virtual void | SetInputArrayToProcess (int idx, int port, int connection, int fieldAssociation, const char *name)
| Set the input data arrays that this algorithm will process. More...
virtual void | SetInputArrayToProcess (int idx, int port, int connection, int fieldAssociation, int fieldAttributeType)
| Set the input data arrays that this algorithm will process. More...
virtual void | SetInputArrayToProcess (int idx, vtkInformation *info)
| Set the input data arrays that this algorithm will process. More...
virtual void | SetInputConnection (int port, vtkAlgorithmOutput *input)
| Set the connection for the given input port index. More...
virtual void | SetInputConnection (vtkAlgorithmOutput *input)
| Set the connection for the given input port index. More...
virtual void | AddInputConnection (int port, vtkAlgorithmOutput *input)
| Add a connection to the given input port index. More...
virtual void | AddInputConnection (vtkAlgorithmOutput *input)
| Add a connection to the given input port index. More...
virtual void | Update (int port)
| Bring this algorithm's outputs up-to-date. More...
virtual void | Update ()
| Bring this algorithm's outputs up-to-date. More...
virtual void | SetReleaseDataFlag (vtkTypeBool)
| Turn release data flag on or off for all output ports. More...
virtual vtkTypeBool | GetReleaseDataFlag ()
| Turn release data flag on or off for all output ports. More...
void | ReleaseDataFlagOn ()
| Turn release data flag on or off for all output ports. More...
void | ReleaseDataFlagOff ()
| Turn release data flag on or off for all output ports. More...
int | UpdateExtentIsEmpty (vtkInformation *pinfo, vtkDataObject *output)
| This detects when the UpdateExtent will generate no data This condition is satisfied when the UpdateExtent has zero volume (0,-1,...) or the UpdateNumberOfPieces is 0. More...
int | UpdateExtentIsEmpty (vtkInformation *pinfo, int extentType)
| This detects when the UpdateExtent will generate no data This condition is satisfied when the UpdateExtent has zero volume (0,-1,...) or the UpdateNumberOfPieces is 0. More...
int * | GetUpdateExtent ()
| These functions return the update extent for output ports that use 3D extents. More...
int * | GetUpdateExtent (int port)
| These functions return the update extent for output ports that use 3D extents. More...
void | GetUpdateExtent (int &x0, int &x1, int &y0, int &y1, int &z0, int &z1)
| These functions return the update extent for output ports that use 3D extents. More...
void | GetUpdateExtent (int port, int &x0, int &x1, int &y0, int &y1, int &z0, int &z1)
| These functions return the update extent for output ports that use 3D extents. More...
void | GetUpdateExtent (int extent[6])
| These functions return the update extent for output ports that use 3D extents. More...
void | GetUpdateExtent (int port, int extent[6])
| These functions return the update extent for output ports that use 3D extents. More...
int | GetUpdatePiece ()
| These functions return the update extent for output ports that use piece extents. More...
int | GetUpdatePiece (int port)
| These functions return the update extent for output ports that use piece extents. More...
int | GetUpdateNumberOfPieces ()
| These functions return the update extent for output ports that use piece extents. More...
int | GetUpdateNumberOfPieces (int port)
| These functions return the update extent for output ports that use piece extents. More...
int | GetUpdateGhostLevel ()
| These functions return the update extent for output ports that use piece extents. More...
int | GetUpdateGhostLevel (int port)
| These functions return the update extent for output ports that use piece extents. More...
void | SetProgressObserver (vtkProgressObserver *)
| If an ProgressObserver is set, the algorithm will report progress through it rather than directly. More...
virtual vtkProgressObserver * | GetProgressObserver ()
| If an ProgressObserver is set, the algorithm will report progress through it rather than directly. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...

## Static Public Member Functions
static vtkSmoothPolyDataFilter * | New ()
| Construct object with number of iterations 20; relaxation factor .01; feature edge smoothing turned off; feature angle 45 degrees; edge angle 15 degrees; and boundary smoothing turned on. More...
Static Public Member Functions inherited from vtkPolyDataAlgorithm
static vtkPolyDataAlgorithm * | New ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkPolyDataAlgorithm * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkAlgorithm
static vtkAlgorithm * | New ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkAlgorithm * | SafeDownCast (vtkObjectBase *o)
static vtkInformationIntegerKey * | INPUT_IS_OPTIONAL ()
| Keys used to specify input port requirements. More...
static vtkInformationIntegerKey * | INPUT_IS_REPEATABLE ()
static vtkInformationInformationVectorKey * | INPUT_REQUIRED_FIELDS ()
static vtkInformationStringVectorKey * | INPUT_REQUIRED_DATA_TYPE ()
static vtkInformationInformationVectorKey * | INPUT_ARRAYS_TO_PROCESS ()
static vtkInformationIntegerKey * | INPUT_PORT ()
static vtkInformationIntegerKey * | INPUT_CONNECTION ()
static vtkInformationIntegerKey * | CAN_PRODUCE_SUB_EXTENT ()
| This key tells the executive that a particular output port is capable of producing an arbitrary subextent of the whole extent. More...
static vtkInformationIntegerKey * | CAN_HANDLE_PIECE_REQUEST ()
| Key that tells the pipeline that a particular algorithm can or cannot handle piece request. More...
static vtkInformationIntegerKey * | ABORTED ()
static void | SetDefaultExecutivePrototype (vtkExecutive *proto)
| If the DefaultExecutivePrototype is set, a copy of it is created in CreateDefaultExecutive() using NewInstance(). More...
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
| vtkSmoothPolyDataFilter ()
| ~vtkSmoothPolyDataFilter () override
int | RequestData (vtkInformation *, vtkInformationVector **, vtkInformationVector *) override
| This is called by the superclass. More...
int | FillInputPortInformation (int port, vtkInformation *info) override
| Fill the input port information objects for this algorithm. More...
Protected Member Functions inherited from vtkPolyDataAlgorithm
| vtkPolyDataAlgorithm ()
| ~vtkPolyDataAlgorithm () override
virtual int | RequestInformation (vtkInformation *request, vtkInformationVector **inputVector, vtkInformationVector *outputVector)
virtual int | RequestUpdateExtent (vtkInformation *, vtkInformationVector **, vtkInformationVector *)
| This is called by the superclass. More...
int | FillOutputPortInformation (int port, vtkInformation *info) override
| Fill the output port information objects for this algorithm. More...
Protected Member Functions inherited from vtkAlgorithm
| vtkAlgorithm ()
| ~vtkAlgorithm () override
bool | CheckUpstreamAbort ()
| Checks to see if an upstream filter has been aborted. More...
virtual void | SetNumberOfInputPorts (int n)
| Set the number of input ports used by the algorithm. More...
virtual void | SetNumberOfOutputPorts (int n)
| Set the number of output ports provided by the algorithm. More...
int | InputPortIndexInRange (int index, const char *action)
int | OutputPortIndexInRange (int index, const char *action)
int | GetInputArrayAssociation (int idx, vtkInformationVector **inputVector)
| Get the association of the actual data array for the input array specified by idx, this is only reasonable during the REQUEST_DATA pass. More...
vtkInformation * | GetInputArrayFieldInformation (int idx, vtkInformationVector **inputVector)
| This method takes in an index (as specified in SetInputArrayToProcess) and a pipeline information vector. More...
virtual vtkExecutive * | CreateDefaultExecutive ()
| Create a default executive. More...
void | ReportReferences (vtkGarbageCollector *) override
virtual void | SetNthInputConnection (int port, int index, vtkAlgorithmOutput *input)
| Replace the Nth connection on the given input port. More...
virtual void | SetNumberOfInputConnections (int port, int n)
| Set the number of input connections on the given input port. More...
void | SetInputDataInternal (int port, vtkDataObject *input)
| These methods are used by subclasses to implement methods to set data objects directly as input. More...
void | AddInputDataInternal (int port, vtkDataObject *input)
int | GetInputArrayAssociation (int idx, int connection, vtkInformationVector **inputVector)
| Filters that have multiple connections on one port can use this signature. More...
int | GetInputArrayAssociation (int idx, vtkDataObject *input)
| Filters that have multiple connections on one port can use this signature. More...
vtkDataArray * | GetInputArrayToProcess (int idx, vtkInformationVector **inputVector)
| Get the actual data array for the input array specified by idx, this is only reasonable during the REQUEST_DATA pass. More...
vtkDataArray * | GetInputArrayToProcess (int idx, vtkInformationVector **inputVector, int &association)
| Get the actual data array for the input array specified by idx, this is only reasonable during the REQUEST_DATA pass. More...
vtkDataArray * | GetInputArrayToProcess (int idx, int connection, vtkInformationVector **inputVector)
| Filters that have multiple connections on one port can use this signature. More...
vtkDataArray * | GetInputArrayToProcess (int idx, int connection, vtkInformationVector **inputVector, int &association)
| Filters that have multiple connections on one port can use this signature. More...
vtkDataArray * | GetInputArrayToProcess (int idx, vtkDataObject *input)
| Filters that have multiple connections on one port can use this signature. More...
vtkDataArray * | GetInputArrayToProcess (int idx, vtkDataObject *input, int &association)
| Filters that have multiple connections on one port can use this signature. More...
vtkAbstractArray * | GetInputAbstractArrayToProcess (int idx, vtkInformationVector **inputVector)
| Get the actual data array for the input array specified by idx, this is only reasonable during the REQUEST_DATA pass. More...
vtkAbstractArray * | GetInputAbstractArrayToProcess (int idx, vtkInformationVector **inputVector, int &association)
| Get the actual data array for the input array specified by idx, this is only reasonable during the REQUEST_DATA pass. More...
vtkAbstractArray * | GetInputAbstractArrayToProcess (int idx, int connection, vtkInformationVector **inputVector)
| Filters that have multiple connections on one port can use this signature. More...
vtkAbstractArray * | GetInputAbstractArrayToProcess (int idx, int connection, vtkInformationVector **inputVector, int &association)
| Filters that have multiple connections on one port can use this signature. More...
vtkAbstractArray * | GetInputAbstractArrayToProcess (int idx, vtkDataObject *input)
| Filters that have multiple connections on one port can use this signature. More...
vtkAbstractArray * | GetInputAbstractArrayToProcess (int idx, vtkDataObject *input, int &association)
| Filters that have multiple connections on one port can use this signature. More...
virtual void | SetErrorCode (unsigned long)
| The error code contains a possible error that occurred while reading or writing the file. More...
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
double | Convergence
int | NumberOfIterations
double | RelaxationFactor
vtkTypeBool | FeatureEdgeSmoothing
double | FeatureAngle
double | EdgeAngle
vtkTypeBool | BoundarySmoothing
vtkTypeBool | GenerateErrorScalars
vtkTypeBool | GenerateErrorVectors
int | OutputPointsPrecision
std::unique_ptr< vtkSmoothPoints > | SmoothPoints
Protected Attributes inherited from vtkAlgorithm
vtkTimeStamp | LastAbortCheckTime
vtkInformation * | Information
double | Progress
char * | ProgressText
vtkProgressObserver * | ProgressObserver
unsigned long | ErrorCode
| The error code contains a possible error that occurred while reading or writing the file. More...
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers
typedef vtkPolyDataAlgorithm | Superclass
| Standard methods to obtain type information, and print the state of a class instance. More...
static vtkTypeBool | IsTypeOf (const char *type)
| Standard methods to obtain type information, and print the state of a class instance. More...
static vtkSmoothPolyDataFilter * | SafeDownCast (vtkObjectBase *o)
| Standard methods to obtain type information, and print the state of a class instance. More...
virtual vtkTypeBool | IsA (const char *type)
| Standard methods to obtain type information, and print the state of a class instance. More...
vtkSmoothPolyDataFilter * | NewInstance () const
| Standard methods to obtain type information, and print the state of a class instance. More...
void | PrintSelf (ostream &os, vtkIndent indent) override
| Standard methods to obtain type information, and print the state of a class instance. More...
virtual vtkObjectBase * | NewInstanceInternal () const
| Standard methods to obtain type information, and print the state of a class instance. More...

## Additional Inherited Members
Public Types inherited from vtkPolyDataAlgorithm
typedef vtkAlgorithm | Superclass
Public Types inherited from vtkAlgorithm
enum | DesiredOutputPrecision { SINGLE_PRECISION , DOUBLE_PRECISION , DEFAULT_PRECISION }
| Values used for setting the desired output precision for various algorithms. More...
typedef vtkObject | Superclass
Public Attributes inherited from vtkAlgorithm
std::atomic< vtkTypeBool > | AbortExecute
Static Protected Member Functions inherited from vtkAlgorithm
static vtkInformationIntegerKey * | PORT_REQUIREMENTS_FILLED ()
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()
Static Protected Attributes inherited from vtkAlgorithm
static vtkTimeStamp | LastAbortTime
static vtkExecutive * | DefaultExecutivePrototype

## Detailed Description

adjust point positions using Laplacian smoothing

vtkSmoothPolyDataFilter is a filter that adjusts point coordinates using Laplacian smoothing. The effect is to "relax" the mesh, making the cells better shaped and the vertices more evenly distributed. Note that this filter operates on the lines, polygons, and triangle strips composing an instance of vtkPolyData. Vertex or poly-vertex cells are never modified.

The algorithm proceeds as follows. For each vertex v, a topological and geometric analysis is performed to determine which vertices are connected to v, and which cells are connected to v. Then, a connectivity array is constructed for each vertex. (The connectivity array is a list of lists of vertices that directly attach to each vertex.) Next, an iteration phase begins over all vertices. For each vertex v, the coordinates of v are modified according to an average of the connected vertices. (A relaxation factor is available to control the amount of displacement of v). The process repeats for each vertex. This pass over the list of vertices is a single iteration. Many iterations (generally around 20 or so) are repeated until the desired result is obtained.

There are some special instance variables used to control the execution of this filter. (These ivars basically control what vertices can be smoothed, and the creation of the connectivity array.) The BoundarySmoothing ivar enables/disables the smoothing operation on vertices that are on the "boundary" of the mesh. A boundary vertex is one that is surrounded by a semi-cycle of polygons (or used by a single line).

Another important ivar is FeatureEdgeSmoothing. If this ivar is enabled, then interior vertices are classified as either "simple", "interior edge", or "fixed", and smoothed differently. (Interior vertices are manifold vertices surrounded by a cycle of polygons; or used by two line cells.) The classification is based on the number of feature edges attached to v. A feature edge occurs when the angle between the two surface normals of a polygon sharing an edge is greater than the FeatureAngle ivar. Then, vertices used by no feature edges are classified "simple", vertices used by exactly two feature edges are classified "interior edge", and all others are "fixed" vertices.

Once the classification is known, the vertices are smoothed differently. Corner (i.e., fixed) vertices are not smoothed at all. Simple vertices are smoothed as before (i.e., average of connected vertex coordinates). Interior edge vertices are smoothed only along their two connected edges, and only if the angle between the edges is less than the EdgeAngle ivar.

The total smoothing can be controlled by using two ivars. The NumberOfIterations is a cap on the maximum number of smoothing passes. The Convergence ivar is a limit on the maximum point motion. If the maximum motion during an iteration is less than Convergence, then the smoothing process terminates. (Convergence is expressed as a fraction of the diagonal of the bounding box.)

There are two instance variables that control the generation of error data. If the ivar GenerateErrorScalars is on, then a scalar value indicating the distance of each vertex from its original position is computed. If the ivar GenerateErrorVectors is on, then a vector representing change in position is computed.

Optionally you can further control the smoothing process by defining a second input: the Source. If defined, the input mesh is constrained to lie on the surface defined by the Source ivar.

Warning
  The Laplacian operation reduces high frequency information in the geometry of the mesh. With excessive smoothing important details may be lost, and the surface may shrink towards the centroid. Enabling FeatureEdgeSmoothing helps reduce this effect, but cannot entirely eliminate it. You may also wish to try vtkWindowedSincPolyDataFilter. It does a better job of minimizing shrinkage. Another option is vtkConstrainedSmoothingFilter which limits the distance that points can move.

See also
  vtkWindowedSincPolyDataFilter vtkConstrainedSmoothingFilter vtkDecimate vtkDecimatePro

Online Examples:

Tests:
  vtkSmoothPolyDataFilter (Tests)

Definition at line 105 of file vtkSmoothPolyDataFilter.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkPolyDataAlgorithm vtkSmoothPolyDataFilter::Superclass

Standard methods to obtain type information, and print the state of a class instance.

Definition at line 122 of file vtkSmoothPolyDataFilter.h.

## Constructor & Destructor Documentation

## ◆ vtkSmoothPolyDataFilter()

vtkSmoothPolyDataFilter::vtkSmoothPolyDataFilter | ( |  | ) |
| protected

## ◆ ~vtkSmoothPolyDataFilter()

vtkSmoothPolyDataFilter::~vtkSmoothPolyDataFilter | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ New()

static vtkSmoothPolyDataFilter* vtkSmoothPolyDataFilter::New | ( |  | ) |
| static

Construct object with number of iterations 20; relaxation factor .01; feature edge smoothing turned off; feature angle 45 degrees; edge angle 15 degrees; and boundary smoothing turned on.

Error scalars and vectors are not generated (by default). The convergence criterion is 0.0 of the bounding box diagonal.

## ◆ IsTypeOf()

static vtkTypeBool vtkSmoothPolyDataFilter::IsTypeOf | ( | const char * | type | ) |
| static

Standard methods to obtain type information, and print the state of a class instance.

## ◆ IsA()

virtual vtkTypeBool vtkSmoothPolyDataFilter::IsA | ( | const char * | type | ) |
| virtual

Standard methods to obtain type information, and print the state of a class instance.

Reimplemented from vtkPolyDataAlgorithm.

## ◆ SafeDownCast()

static vtkSmoothPolyDataFilter* vtkSmoothPolyDataFilter::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

Standard methods to obtain type information, and print the state of a class instance.

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkSmoothPolyDataFilter::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Standard methods to obtain type information, and print the state of a class instance.

Reimplemented from vtkPolyDataAlgorithm.

## ◆ NewInstance()

vtkSmoothPolyDataFilter* vtkSmoothPolyDataFilter::NewInstance | ( |  | ) | const

Standard methods to obtain type information, and print the state of a class instance.

## ◆ PrintSelf()

void vtkSmoothPolyDataFilter::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Standard methods to obtain type information, and print the state of a class instance.

Reimplemented from vtkPolyDataAlgorithm.

## ◆ SetConvergence()

virtual void vtkSmoothPolyDataFilter::SetConvergence | ( | double |  | ) |
| virtual

Specify a convergence criterion for the iteration process.

Smaller numbers result in more smoothing iterations.

## ◆ GetConvergence()

virtual double vtkSmoothPolyDataFilter::GetConvergence | ( |  | ) |
| virtual

Specify a convergence criterion for the iteration process.

Smaller numbers result in more smoothing iterations.

## ◆ SetNumberOfIterations()

virtual void vtkSmoothPolyDataFilter::SetNumberOfIterations | ( | int |  | ) |
| virtual

Specify the number of iterations for Laplacian smoothing,.

## ◆ GetNumberOfIterations()

virtual int vtkSmoothPolyDataFilter::GetNumberOfIterations | ( |  | ) |
| virtual

Specify the number of iterations for Laplacian smoothing,.

## ◆ SetRelaxationFactor()

virtual void vtkSmoothPolyDataFilter::SetRelaxationFactor | ( | double |  | ) |
| virtual

Specify the relaxation factor for Laplacian smoothing.

As in all iterative methods, the stability of the process is sensitive to this parameter. In general, small relaxation factors and large numbers of iterations are more stable than larger relaxation factors and smaller numbers of iterations.

## ◆ GetRelaxationFactor()

virtual double vtkSmoothPolyDataFilter::GetRelaxationFactor | ( |  | ) |
| virtual

Specify the relaxation factor for Laplacian smoothing.

As in all iterative methods, the stability of the process is sensitive to this parameter. In general, small relaxation factors and large numbers of iterations are more stable than larger relaxation factors and smaller numbers of iterations.

## ◆ SetFeatureEdgeSmoothing()

virtual void vtkSmoothPolyDataFilter::SetFeatureEdgeSmoothing | ( | vtkTypeBool |  | ) |
| virtual

Turn on/off smoothing along sharp interior edges.

## ◆ GetFeatureEdgeSmoothing()

virtual vtkTypeBool vtkSmoothPolyDataFilter::GetFeatureEdgeSmoothing | ( |  | ) |
| virtual

Turn on/off smoothing along sharp interior edges.

## ◆ FeatureEdgeSmoothingOn()

virtual void vtkSmoothPolyDataFilter::FeatureEdgeSmoothingOn | ( |  | ) |
| virtual

Turn on/off smoothing along sharp interior edges.

## ◆ FeatureEdgeSmoothingOff()

virtual void vtkSmoothPolyDataFilter::FeatureEdgeSmoothingOff | ( |  | ) |
| virtual

Turn on/off smoothing along sharp interior edges.

## ◆ SetFeatureAngle()

virtual void vtkSmoothPolyDataFilter::SetFeatureAngle | ( | double |  | ) |
| virtual

Specify the feature angle for sharp edge identification.

## ◆ GetFeatureAngle()

virtual double vtkSmoothPolyDataFilter::GetFeatureAngle | ( |  | ) |
| virtual

Specify the feature angle for sharp edge identification.

## ◆ SetEdgeAngle()

virtual void vtkSmoothPolyDataFilter::SetEdgeAngle | ( | double |  | ) |
| virtual

Specify the edge angle to control smoothing along edges (either interior or boundary).

## ◆ GetEdgeAngle()

virtual double vtkSmoothPolyDataFilter::GetEdgeAngle | ( |  | ) |
| virtual

Specify the edge angle to control smoothing along edges (either interior or boundary).

## ◆ SetBoundarySmoothing()

virtual void vtkSmoothPolyDataFilter::SetBoundarySmoothing | ( | vtkTypeBool |  | ) |
| virtual

Turn on/off the smoothing of vertices on the boundary of the mesh.

## ◆ GetBoundarySmoothing()

virtual vtkTypeBool vtkSmoothPolyDataFilter::GetBoundarySmoothing | ( |  | ) |
| virtual

Turn on/off the smoothing of vertices on the boundary of the mesh.

## ◆ BoundarySmoothingOn()

virtual void vtkSmoothPolyDataFilter::BoundarySmoothingOn | ( |  | ) |
| virtual

Turn on/off the smoothing of vertices on the boundary of the mesh.

## ◆ BoundarySmoothingOff()

virtual void vtkSmoothPolyDataFilter::BoundarySmoothingOff | ( |  | ) |
| virtual

Turn on/off the smoothing of vertices on the boundary of the mesh.

## ◆ SetGenerateErrorScalars()

virtual void vtkSmoothPolyDataFilter::SetGenerateErrorScalars | ( | vtkTypeBool |  | ) |
| virtual

Turn on/off the generation of scalar distance values.

## ◆ GetGenerateErrorScalars()

virtual vtkTypeBool vtkSmoothPolyDataFilter::GetGenerateErrorScalars | ( |  | ) |
| virtual

Turn on/off the generation of scalar distance values.

## ◆ GenerateErrorScalarsOn()

virtual void vtkSmoothPolyDataFilter::GenerateErrorScalarsOn | ( |  | ) |
| virtual

Turn on/off the generation of scalar distance values.

## ◆ GenerateErrorScalarsOff()

virtual void vtkSmoothPolyDataFilter::GenerateErrorScalarsOff | ( |  | ) |
| virtual

Turn on/off the generation of scalar distance values.

## ◆ SetGenerateErrorVectors()

virtual void vtkSmoothPolyDataFilter::SetGenerateErrorVectors | ( | vtkTypeBool |  | ) |
| virtual

Turn on/off the generation of error vectors.

## ◆ GetGenerateErrorVectors()

virtual vtkTypeBool vtkSmoothPolyDataFilter::GetGenerateErrorVectors | ( |  | ) |
| virtual

Turn on/off the generation of error vectors.

## ◆ GenerateErrorVectorsOn()

virtual void vtkSmoothPolyDataFilter::GenerateErrorVectorsOn | ( |  | ) |
| virtual

Turn on/off the generation of error vectors.

## ◆ GenerateErrorVectorsOff()

virtual void vtkSmoothPolyDataFilter::GenerateErrorVectorsOff | ( |  | ) |
| virtual

Turn on/off the generation of error vectors.

## ◆ SetSourceData()

void vtkSmoothPolyDataFilter::SetSourceData | ( | vtkPolyData * | source | ) |

Specify the source object which is used to constrain smoothing.

The source defines a surface that the input (as it is smoothed) is constrained to lie upon.

## ◆ GetSource()

vtkPolyData* vtkSmoothPolyDataFilter::GetSource | ( |  | ) |

Specify the source object which is used to constrain smoothing.

The source defines a surface that the input (as it is smoothed) is constrained to lie upon.

## ◆ SetOutputPointsPrecision()

virtual void vtkSmoothPolyDataFilter::SetOutputPointsPrecision | ( | int |  | ) |
| virtual

Set/get the desired precision for the output types.

See the documentation for the vtkAlgorithm::DesiredOutputPrecision enum for an explanation of the available precision settings.

## ◆ GetOutputPointsPrecision()

virtual int vtkSmoothPolyDataFilter::GetOutputPointsPrecision | ( |  | ) |
| virtual

Set/get the desired precision for the output types.

See the documentation for the vtkAlgorithm::DesiredOutputPrecision enum for an explanation of the available precision settings.

## ◆ RequestData()

int vtkSmoothPolyDataFilter::RequestData | ( | vtkInformation * | request,
|  | vtkInformationVector ** | inputVector,
|  | vtkInformationVector * | outputVector
| ) |  |
| overrideprotectedvirtual

This is called by the superclass.

This is the method you should override.

Reimplemented from vtkPolyDataAlgorithm.

## ◆ FillInputPortInformation()

int vtkSmoothPolyDataFilter::FillInputPortInformation | ( | int | port,
|  | vtkInformation * | info
| ) |  |
| overrideprotectedvirtual

Fill the input port information objects for this algorithm.

This is invoked by the first call to GetInputPortInformation for each port so subclasses can specify what they can handle.

Reimplemented from vtkPolyDataAlgorithm.

## Member Data Documentation

## ◆ Convergence

double vtkSmoothPolyDataFilter::Convergence
| protected

Definition at line 235 of file vtkSmoothPolyDataFilter.h.

## ◆ NumberOfIterations

int vtkSmoothPolyDataFilter::NumberOfIterations
| protected

Definition at line 236 of file vtkSmoothPolyDataFilter.h.

## ◆ RelaxationFactor

double vtkSmoothPolyDataFilter::RelaxationFactor
| protected

Definition at line 237 of file vtkSmoothPolyDataFilter.h.

## ◆ FeatureEdgeSmoothing

vtkTypeBool vtkSmoothPolyDataFilter::FeatureEdgeSmoothing
| protected

Definition at line 238 of file vtkSmoothPolyDataFilter.h.

## ◆ FeatureAngle

double vtkSmoothPolyDataFilter::FeatureAngle
| protected

Definition at line 239 of file vtkSmoothPolyDataFilter.h.

## ◆ EdgeAngle

double vtkSmoothPolyDataFilter::EdgeAngle
| protected

Definition at line 240 of file vtkSmoothPolyDataFilter.h.

## ◆ BoundarySmoothing

vtkTypeBool vtkSmoothPolyDataFilter::BoundarySmoothing
| protected

Definition at line 241 of file vtkSmoothPolyDataFilter.h.

## ◆ GenerateErrorScalars

vtkTypeBool vtkSmoothPolyDataFilter::GenerateErrorScalars
| protected

Definition at line 242 of file vtkSmoothPolyDataFilter.h.

## ◆ GenerateErrorVectors

vtkTypeBool vtkSmoothPolyDataFilter::GenerateErrorVectors
| protected

Definition at line 243 of file vtkSmoothPolyDataFilter.h.

## ◆ OutputPointsPrecision

int vtkSmoothPolyDataFilter::OutputPointsPrecision
| protected

Definition at line 244 of file vtkSmoothPolyDataFilter.h.

## ◆ SmoothPoints

std::unique_ptr<vtkSmoothPoints> vtkSmoothPolyDataFilter::SmoothPoints
| protected

Definition at line 246 of file vtkSmoothPolyDataFilter.h.

The documentation for this class was generated from the following file:

- Filters/Core/vtkSmoothPolyDataFilter.h